// MemoRecvAttachList.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "MemoRecvAttachList.h"
#include "AtatchDownload.h"
#include "NeMessengerDlg.h"
// CMemoRecvAttachList

IMPLEMENT_DYNAMIC(CMemoRecvAttachList, CWnd)

CMemoRecvAttachList::CMemoRecvAttachList() : m_pImgBG(NULL), m_pImgFile(NULL), m_pImgDownload(NULL), m_dwTotalSize(0), m_nScrollPageSize(0), m_bTracking(FALSE)
{
	m_crBG = DEF_MEMORECV_LIST_BG_COLOR;
	m_crOutline = DEF_MEMORECV_LIST_BGOUTLINE_COLOR;
	// dimension
	m_rtWnd.SetRectEmpty();
	m_nScrollOneSize = DEF_MEMORECV_LIST_SCROLL_SIZE;

}

CMemoRecvAttachList::~CMemoRecvAttachList()
{
}

BEGIN_MESSAGE_MAP(CMemoRecvAttachList, CWnd)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSEHOVER()
	ON_WM_MOUSELEAVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_SETCURSOR()
	ON_WM_SIZE()
	ON_WM_MOUSEWHEEL()
	ON_WM_KEYDOWN()
	ON_WM_VSCROLL()
END_MESSAGE_MAP()

void CMemoRecvAttachList::SetImgBGPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgBG = new Image(strImgPath);
}

void CMemoRecvAttachList::SetImgFilePath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgFile = new Image(strImgPath);
}

void CMemoRecvAttachList::SetImgDownloadPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
		return;
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgDownload = new Image(strImgPath);
}

void CMemoRecvAttachList::SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText)
{
	_tcscpy_s(m_wszFontName, wszFontName);
	m_nFontHeight = nFontHeight;
	m_fontStyle = style;

	m_crText = crText;
}

CString	CMemoRecvAttachList::GetFileItemDownloadURL(int nIdx)
{
	_memorecv_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nIdx >= nCntItem)
		return _T("");

	pFileItem = (_memorecv_file_item*)m_ptrArFileItem.GetAt(nIdx);
	if (!pFileItem)
		return _T("");

	return pFileItem->strDownloadURL;
}

CString	CMemoRecvAttachList::GetFileItemName(int nIdx)
{
	_memorecv_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nIdx >= nCntItem)
		return _T("");

	pFileItem = (_memorecv_file_item*)m_ptrArFileItem.GetAt(nIdx);
	if (!pFileItem)
		return _T("");

	return pFileItem->strName;
}

ULONGLONG CMemoRecvAttachList::GetFileItemTotalSize(int nIdx)
{
	_memorecv_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nIdx >= nCntItem)
		return 0;

	pFileItem = (_memorecv_file_item*)m_ptrArFileItem.GetAt(nIdx);
	if (!pFileItem)
		return 0;

	return pFileItem->dwTotalSize;
}

ULONGLONG CMemoRecvAttachList::GetFileItemCurRecvSize(int nIdx)
{
	_memorecv_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nIdx >= nCntItem)
		return 0;

	pFileItem = (_memorecv_file_item*)m_ptrArFileItem.GetAt(nIdx);
	if (!pFileItem)
		return 0;

	return pFileItem->dwCurSendSize;
}

ULONGLONG CMemoRecvAttachList::GetFileItemTotalSizeAll()
{
	_memorecv_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nCntItem <= 0)
		return 0;

	ULONGLONG dwTotalSize = 0;
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memorecv_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		dwTotalSize += pFileItem->dwTotalSize;
	}

	return dwTotalSize;
}

ULONGLONG CMemoRecvAttachList::GetFileItemCurRecvSizeAll()
{
	_memorecv_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nCntItem <= 0)
		return 0;

	ULONGLONG dwCurSendSize = 0;
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memorecv_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		dwCurSendSize += pFileItem->dwCurSendSize;
	}

	return dwCurSendSize;
}

void CMemoRecvAttachList::ClearFileItemAll()
{
	_memorecv_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memorecv_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		delete pFileItem;
	}
	m_ptrArFileItem.RemoveAll();
}

CMemoRecvAttachList::_memorecv_file_item* CMemoRecvAttachList::AllocFileItem(CString strDownloadURL, CString strName, ULONGLONG dwFileSize)
{
	CMemoRecvAttachList::_memorecv_file_item* pFileItem = new CMemoRecvAttachList::_memorecv_file_item;
	if (!pFileItem)
		return NULL;

	pFileItem->strDownloadURL = strDownloadURL;
	pFileItem->strName = strName;
	pFileItem->strShowName = strName;
	if (pFileItem->strShowName.GetLength() > 42)
	{
		pFileItem->strShowName = pFileItem->strShowName.Left(42) + _T("");
	}
	pFileItem->dwTotalSize = dwFileSize;

	ULONGLONG dwRemainSize = pFileItem->dwTotalSize % 1024;
	ULONGLONG dwKiloSize = pFileItem->dwTotalSize / 1024;
	if (dwRemainSize > 0)
		dwKiloSize += 1;

	CString strKiloSize = _T("");
	strKiloSize.Format(_T("%d"), (INT)dwKiloSize);
	pFileItem->strSize = InsertCharToString(strKiloSize, 3, _T(','));
	pFileItem->strSize += _T("KB");

	return pFileItem;
}

BOOL CMemoRecvAttachList::AddFileItem(CString strDownloadURL, CString strName, ULONGLONG dwFileSize)
{
	_memorecv_file_item* pFileItem = NULL, *pFileItemLast = NULL;
	pFileItem = AllocFileItem(strDownloadURL, strName, dwFileSize);
	if (!pFileItem)
		return FALSE;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nCntItem > 0)
		pFileItemLast = (_memorecv_file_item*)m_ptrArFileItem.GetAt(nCntItem - 1);

	int nSX = 0, nSY = 0, nCX = 0, nCY = 0, nEX = 0, nEY = 0, nImgWidth = 0, nImgHeight = 0;

	nSX = DEF_MEMORECV_LIST_IMG_POS_LEFT_X;
	nSY = DEF_MEMORECV_LIST_IMG_POS_TOP_Y;
	if (pFileItemLast)
		nSY = pFileItemLast->rtItem.bottom;
	nCX = m_rtWnd.Width() - (DEF_MEMORECV_LIST_IMG_POS_LEFT_X + DEF_MEMORECV_LIST_SCROLL_SIZE);
	nCY = DEF_MEMORECV_LIST_ITEM_HEIGHT;
	pFileItem->rtItem.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	if (m_pImgFile)
	{
		nImgWidth = m_pImgFile->GetWidth();
		nImgHeight = m_pImgFile->GetHeight();

		nSX = pFileItem->rtItem.left;
		nSY = pFileItem->rtItem.top + (pFileItem->rtItem.Height() - nImgHeight) / 2;
		nCX = nImgWidth;
		nCY = nImgHeight;
		pFileItem->rtImgFile.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);
	}

	CSize szName(0, 0);
	CRect rtName(0, 0, 500, 500);
	REAL nFontHeight = DEF_MEMORECV_LIST_FILE_FONT_HEIGHT;
	RecalcTextRect(this, pFileItem->strShowName, DEF_MEMORECV_LIST_FONT_NAME, nFontHeight, DEF_MEMORECV_LIST_FILE_FONT_STYLE, rtName, szName);

	pFileItem->szName = szName;

	if (m_pImgDownload)
	{
		nImgWidth = m_pImgDownload->GetWidth();
		nImgHeight = m_pImgDownload->GetHeight();

		nSX = pFileItem->rtItem.right - nImgWidth;
		nSY = pFileItem->rtItem.top + (pFileItem->rtItem.Height() - nImgHeight) / 2;
		nCX = nImgWidth;
		nCY = nImgHeight;
		pFileItem->rtImgDownload.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);
	}

	nSX = pFileItem->rtItem.right - pFileItem->rtImgDownload.Width() - DEF_MEMORECV_LIST_SIZE_WIDTH;
	nSY = pFileItem->rtItem.top + (pFileItem->rtItem.Height() - szName.cy) / 2;
	nCX = DEF_MEMORECV_LIST_SIZE_WIDTH;
	nCY = szName.cy;
	pFileItem->rtSize.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

	nSX = pFileItem->rtImgFile.right + DEF_MEMORECV_LIST_IMG_NAME_GAP_X;
	nSY = pFileItem->rtItem.top + (pFileItem->rtItem.Height() - szName.cy) / 2;
	nEX = pFileItem->rtSize.left;
	nCY = szName.cy;
	pFileItem->rtName.SetRect(nSX, nSY, nEX, nSY + nCY);

	m_ptrArFileItem.Add(pFileItem);

	UpdateScrollInfo();

	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

	return TRUE;
}

void CMemoRecvAttachList::RecalcFileItem()
{
	_memorecv_file_item* pFileItem = NULL, *pFileItemFirst = NULL, *pFileItemLast = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nCntItem <= 0)
		return;

	pFileItemFirst = (_memorecv_file_item*)m_ptrArFileItem.GetAt(0);
	if (!pFileItemFirst)
		return;

	pFileItemLast = (_memorecv_file_item*)m_ptrArFileItem.GetAt(nCntItem - 1);
	if (!pFileItemLast)
		return;

	int nDiffWidth = 0, nDiffHeight = 0;
	int nSX = 0, nSY = 0, nCX = 0, nCY = 0, nEX = 0, nEY = 0, nImgWidth = 0, nImgHeight = 0;

	if (pFileItemFirst->rtItem.top < 0 && pFileItemLast->rtItem.bottom < m_rtWnd.Height())
	{
		nDiffHeight = m_rtWnd.Height() - pFileItemLast->rtItem.bottom;
		//ScrollItem(nDiffHeight);
	}

	CRect rtClient(0, 0, 0, 0);
	GetClientRect(&rtClient);

	int nWidth = rtClient.Width();
	nDiffWidth = nWidth - pFileItemFirst->rtItem.Width();

	int nOffsetY = 0;
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memorecv_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		pFileItem->rtItem.right = nWidth - DEF_MEMORECV_LIST_SCROLL_SIZE;

		if (m_pImgDownload)
		{
			nImgWidth = m_pImgDownload->GetWidth();
			nImgHeight = m_pImgDownload->GetHeight();

			nSX = pFileItem->rtItem.right - nImgWidth;
			nSY = pFileItem->rtItem.top + (pFileItem->rtItem.Height() - nImgHeight) / 2;
			nCX = nImgWidth;
			nCY = nImgHeight;
			pFileItem->rtImgDownload.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);
		}

		nSX = pFileItem->rtItem.right - pFileItem->rtImgDownload.Width() - DEF_MEMORECV_LIST_SIZE_WIDTH;
		nSY = pFileItem->rtItem.top + (pFileItem->rtItem.Height() - pFileItem->szName.cy) / 2;
		nCX = DEF_MEMORECV_LIST_SIZE_WIDTH;
		nCY = pFileItem->szName.cy;
		pFileItem->rtSize.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

		nSX = pFileItem->rtImgFile.right + DEF_MEMORECV_LIST_IMG_NAME_GAP_X;
		nSY = pFileItem->rtItem.top + (pFileItem->rtItem.Height() - pFileItem->szName.cy) / 2;
		nEX = pFileItem->rtSize.left;
		nCY = pFileItem->szName.cy;
		pFileItem->rtName.SetRect(nSX, nSY, nEX, nSY + nCY);
	}

	//UpdateScrollInfo();

	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CMemoRecvAttachList::UpdateScrollInfo()
{
	_memorecv_file_item* pFileItem = NULL, *pFileItemFirst = NULL, *pFileItemLast = NULL;

	m_nScrollPageSize = m_rtWnd.Height();

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nCntItem <= 0)
		return;

	pFileItemFirst = (_memorecv_file_item*)m_ptrArFileItem.GetAt(0);
	if (!pFileItemFirst)
		return;

	pFileItemLast = (_memorecv_file_item*)m_ptrArFileItem.GetAt(nCntItem - 1);
	if (!pFileItemLast)
		return;

	int nWndHeight = m_rtWnd.Height();
	int nItemHeight = pFileItemLast->rtItem.bottom - pFileItemFirst->rtItem.top;

	if (nItemHeight > nWndHeight)
	{
		if (!m_wndScrollBar.IsWindowVisible())
		{
			m_wndScrollBar.ShowScrollBar(TRUE);
		}
	}
	else
	{
		if (m_wndScrollBar.IsWindowVisible())
		{
			m_wndScrollBar.ShowScrollBar(FALSE);
			if (pFileItemFirst->rtItem.top < 0)
			{
				int nDiff = m_rtWnd.top - pFileItemFirst->rtItem.top;
				ScrollItem(nDiff);
			}
		}
	}

	m_wndScrollBar.SetScrollRange(0, nItemHeight);
	m_wndScrollBar.SetScrollPos(abs(pFileItemFirst->rtItem.top));
	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_ALL;
	si.nMin = 0;
	si.nMax = nItemHeight;
	si.nPage = nWndHeight;
	si.nPos = abs(pFileItemFirst->rtItem.top);
	si.nTrackPos = si.nPos;
	m_wndScrollBar.SetScrollInfo(&si);
}

BOOL CMemoRecvAttachList::ScrollItem(int nDiff)
{
	if (nDiff == 0)
		return FALSE;

	_memorecv_file_item* pFileItem = NULL, *pFileItemFirst = NULL, *pFileItemLast = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	if (nCntItem <= 0)
		return FALSE;

	pFileItemFirst = (_memorecv_file_item*)m_ptrArFileItem.GetAt(0);
	if (!pFileItemFirst)
		return FALSE;

	pFileItemLast = (_memorecv_file_item*)m_ptrArFileItem.GetAt(nCntItem - 1);
	if (!pFileItemLast)
		return FALSE;

	int nAdjustDiff = 0;
	if (nDiff > 0)
	{
		if (pFileItemFirst->rtItem.top >= 0)
			return FALSE;

		nAdjustDiff = nDiff - abs(pFileItemFirst->rtItem.top);
		if (nAdjustDiff > 0)
			nDiff = abs(pFileItemFirst->rtItem.top);
	}
	else
	{
		if (pFileItemLast->rtItem.bottom <= m_rtWnd.Height())
			return FALSE;

		nAdjustDiff = abs(nDiff) - abs(pFileItemLast->rtItem.bottom - m_rtWnd.Height());
		if (nAdjustDiff > 0)
			nDiff = abs(pFileItemLast->rtItem.bottom - m_rtWnd.Height()) * (-1);
	}

	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memorecv_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		pFileItem->rtItem.OffsetRect(0, nDiff);
		pFileItem->rtImgFile.OffsetRect(0, nDiff);
		pFileItem->rtName.OffsetRect(0, nDiff);		
		pFileItem->rtSize.OffsetRect(0, nDiff);
		pFileItem->rtImgDownload.OffsetRect(0, nDiff);
	}

	return TRUE;
}

// CMemoRecvAttachList ޽ óԴϴ.

int CMemoRecvAttachList::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndScrollBar.Create(WS_CHILD | SBS_VERT, CRect(0, 0, 0, 0), this, ID_MEMORECV_SCROLLBAR))
		return -1;

	return 0;
}

void CMemoRecvAttachList::OnDestroy()
{
	if (m_pImgBG)
	{
		delete m_pImgBG;
		m_pImgBG = NULL;
	}

	if (m_pImgFile)
	{
		delete m_pImgFile;
		m_pImgFile = NULL;
	}

	if (m_pImgDownload)
	{
		delete m_pImgDownload;
		m_pImgDownload = NULL;
	}

	ClearFileItemAll();

	CWnd::OnDestroy();
}

BOOL CMemoRecvAttachList::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
}

void CMemoRecvAttachList::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	PAINTSTRUCT ps = dc.m_ps;
	int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;

	int nPX = ps.rcPaint.left;
	int nPY = ps.rcPaint.top;

	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

	CRect rt(0, 0, 0, 0);
	GetClientRect(&rt);
	int nWndWidth = rt.Width();
	int nWndHeight = rt.Height();

	HDC hdc = dc.GetSafeHdc();

	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		ImageAttributes ImgAttr;

		SolidBrush brushBG(m_crBG);
		Pen penBG(m_crOutline, 1);
		int nSX = 0, nSY = 0, nCX = 0, nCY = 0;
		if (m_pImgBG)
			DrawImageToStretchHorz(&graph, m_pImgBG, &rtPS, &m_rtWnd, m_crBG, &ImgAttr);
		else
		{
			nSX = m_rtWnd.left - rtPS.left;
			nSY = m_rtWnd.top - rtPS.top;
			nCX = m_rtWnd.Width();
			nCY = m_rtWnd.Height();
			graph.FillRectangle(&brushBG, nSX - 1, nSY - 1, nCX + 1, nCY + 1);
			graph.DrawRectangle(&penBG, nSX - 1, nSY, nCX + 1, nCY - 1);
		}

		int nCntFileAttach = m_ptrArFileItem.GetCount();
		
		_memorecv_file_item* pFileItem = NULL;

		int nCntItem = m_ptrArFileItem.GetCount();
		for (int i = 0; i < nCntItem; i++)
		{
			pFileItem = (_memorecv_file_item*)m_ptrArFileItem.GetAt(i);
			if (!pFileItem)
				continue;

			if (m_pImgFile)
				DrawImageToDest(&graph, m_pImgFile, &rtPS, &(pFileItem->rtImgFile), &ImgAttr);

			if (!(pFileItem->strShowName.IsEmpty()))
			{
				DrawTextToDest2(&graph,
								pFileItem->strShowName, &rtPS, &(pFileItem->rtName),
								DEF_MEMORECV_LIST_FONT_NAME, DEF_MEMORECV_LIST_FILE_FONT_HEIGHT,
								StringAlignmentNear,
								DEF_MEMORECV_LIST_FILE_FONT_STYLE,
								DEF_MEMORECV_LIST_FILE_FONT_COLOR);
			}

			if (!(pFileItem->strSize.IsEmpty()))
			{
				DrawTextToDest2(&graph,
								pFileItem->strSize, &rtPS, &(pFileItem->rtSize),
								DEF_MEMORECV_LIST_FONT_NAME, DEF_MEMORECV_LIST_FILE_FONT_HEIGHT,
								StringAlignmentFar,
								DEF_MEMORECV_LIST_FILE_FONT_STYLE,
								DEF_MEMORECV_LIST_FILE_FONT_COLOR);
			}

			if (m_pImgDownload)
				DrawImageToDest(&graph, m_pImgDownload, &rtPS, &(pFileItem->rtImgDownload), &ImgAttr);
		}

		BitBlt(dc.GetSafeHdc(), nPX, nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);
	}

	::DeleteDC(hdcMemory);
}

void CMemoRecvAttachList::OnMouseMove(UINT nFlags, CPoint point)
{
	if (!m_bTracking)
	{
		m_bTracking = TRUE;

		TRACKMOUSEEVENT tme;
		tme.cbSize = sizeof(TRACKMOUSEEVENT);
		tme.dwFlags = TME_HOVER | TME_LEAVE;
		tme.dwHoverTime = 1;
		tme.hwndTrack = GetSafeHwnd();
		TrackMouseEvent(&tme);
	}

	CWnd::OnMouseMove(nFlags, point);
}

void CMemoRecvAttachList::OnMouseHover(UINT nFlags, CPoint point)
{

}

void CMemoRecvAttachList::OnMouseLeave()
{
	m_bTracking = FALSE;

	if (GetAsyncKeyState(VK_LBUTTON) & 0x8000)
	{
	}
	else
	{
		_memorecv_file_item* pFileItem = NULL;

		int nCntItem = m_ptrArFileItem.GetCount();
		for (int i = 0; i < nCntItem; i++)
		{
			pFileItem = (_memorecv_file_item*)m_ptrArFileItem.GetAt(i);
			if (!pFileItem)
				continue;

			if (pFileItem->bDown)
			{
				ReleaseCapture();								
			}
			pFileItem->bDown = FALSE;
		}
	}
}

void CMemoRecvAttachList::OnLButtonDown(UINT nFlags, CPoint point)
{
	SetFocus();

	_memorecv_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memorecv_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		if (pFileItem->rtImgDownload.PtInRect(point) || pFileItem->rtName.PtInRect(point))
		{
			SetCapture();
			pFileItem->bDown = TRUE;
			return;
		}
	}

	CWnd::OnLButtonDown(nFlags, point);
}

void CMemoRecvAttachList::OnLButtonUp(UINT nFlags, CPoint point)
{
	ReleaseCapture();		

	_memorecv_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	for (int i = nCntItem - 1; i >= 0; i--)
	{
		pFileItem = (_memorecv_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		if (pFileItem->bDown && (pFileItem->rtImgDownload.PtInRect(point) || pFileItem->rtName.PtInRect(point)))
		{
			DownloadFileItem(pFileItem);
		}

		pFileItem->bDown = FALSE;
	}

	CWnd::OnLButtonUp(nFlags, point);
}

void CMemoRecvAttachList::DownloadFileItem(_memorecv_file_item* pFileItem)
{
	if (!pFileItem)
		return;

	CAtatchDownload dlg(this);	
	ULONGLONG dwFileSize = 0;
	CString strSize = _T(""), strURL = _T(""), strFileName = _T("");		

	strURL = pFileItem->strDownloadURL;
	strFileName = pFileItem->strName;
	dwFileSize = pFileItem->dwTotalSize;
	strSize.Format(_T("%d"), (INT)dwFileSize);	

	dlg.AddDownloadFile(strURL, GET_CONFIG()->GetRecvFolder(), strFileName, strSize);
	dlg.SetOpenFolderAfterDownload(GET_CONFIG()->IsOpenFolderAfterDownload());

    GET_MESSENGER_DLG()->RegisterMfcModalDlg(&dlg);
    int nRet = dlg.DoModal();
    GET_MESSENGER_DLG()->UnRegisterMfcModalDlg(&dlg);
}

BOOL CMemoRecvAttachList::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	CPoint pt(0, 0);
	GetCursorPos(&pt);
	ScreenToClient(&pt);

	_memorecv_file_item* pFileItem = NULL;

	int nCntItem = m_ptrArFileItem.GetCount();
	for (int i = 0; i < nCntItem; i++)
	{
		pFileItem = (_memorecv_file_item*)m_ptrArFileItem.GetAt(i);
		if (!pFileItem)
			continue;

		if (pFileItem->rtImgDownload.PtInRect(pt) || pFileItem->rtName.PtInRect(pt))
		{
			::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_HAND));
			return TRUE;
		}
	}

	return CWnd::OnSetCursor(pWnd, nHitTest, message);
}

BOOL CMemoRecvAttachList::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	long lScrollValue = m_nScrollOneSize * zDelta / 120;

	if (ScrollItem(lScrollValue))
	{
		UpdateScrollInfo();

		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	}

	return CWnd::OnMouseWheel(nFlags, zDelta, pt);
}

void CMemoRecvAttachList::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	long lScrollValue = 0;

	switch (nChar)
	{
	case VK_DOWN:
		{
			lScrollValue = m_nScrollOneSize * (-1);
		}
		break;
	case VK_UP:
		{
			lScrollValue = m_nScrollOneSize * (1);
		}
		break;
	case VK_NEXT:
		{
			lScrollValue = m_nScrollPageSize * (-1);
		}
		break;
	case VK_PRIOR:
		{
			lScrollValue = m_nScrollPageSize * (1);
		}
		break;
	}

	if (ScrollItem(lScrollValue))
	{
		UpdateScrollInfo();

		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	}

	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CMemoRecvAttachList::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	long lScrollValue = 0;

	switch (nSBCode)
	{
	case SB_TOP:
	case SB_LINEUP:
		{
			lScrollValue = m_nScrollOneSize * (1);
		}
		break;
	case SB_BOTTOM:
	case SB_LINEDOWN:
		{
			lScrollValue = m_nScrollOneSize * (-1);
		}
		break;
	case SB_PAGEUP:
		{
			lScrollValue = m_nScrollPageSize * (1);
		}
		break;
	case SB_PAGEDOWN:
		{
			lScrollValue = m_nScrollPageSize * (-1);
		}
		break;
	case SB_THUMBTRACK:
		{
			int nCurPos = m_wndScrollBar.GetScrollPos();
			lScrollValue = nCurPos - nPos;
		}
		break;
	}

	if (ScrollItem(lScrollValue))
	{
		UpdateScrollInfo();

		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	}

	CWnd::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CMemoRecvAttachList::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	m_rtWnd.SetRect(0, 0, cx, cy);

	int nSX = 0, nSY = 0, nCX = 0, nCY = 0;
	if (m_wndScrollBar.GetSafeHwnd())
	{
		nCX = GetSystemMetrics(SM_CXVSCROLL);
		nSX = m_rtWnd.right - nCX;
		nSY = m_rtWnd.top;
		nCY = m_rtWnd.Height();	
		m_rtScrollBar.SetRect(nSX, nSY, nSX + nCX, nSY + nCY);

		m_wndScrollBar.MoveWindow(&m_rtScrollBar);
	}

	RecalcFileItem();
}
